eosio proposal tools
====================

Install
-------

### 1. Copy the scripts

First run the `make install` command or copy the contents of `bin/` manually to a path contained in `$PATH`

### 3. Install jq

`jq` needs to be installed, on ubuntu you can install it via `sudo apt-get install jq`

### 4. Install/Compile eosio-unpack-abi

You also need the `eosio-unpack-abi` program.

This can be compiled or installed via deb package manager at: https://github.com/eosswedenorg/eosio-unpack-abi

Validation proposals
--------------------

Get the proposal from the chain:

```sh
$ cleos multisig review <proposal_account> <proposal> > some_proposal.json
```

### Validate wasm

```sh
$ proposal_check_wasm /path/to/compiled.wasm some_proposal.json
Proposal hash:	90f436cd4e13f6ad2b634a996c63818a827b7ba49c877831bd7f6d132ace1f39
Wasm hash:	90f436cd4e13f6ad2b634a996c63818a827b7ba49c877831bd7f6d132ace1f39
Hashes matches
```

If hash matches. all is fine.

### Validate abi

```sh
$ proposal_check_abi /path/to/generated.abi some_proposal.json
prop	|	abi
1a2
>   "____comment": "This file was generated with eosio-abigen. DO NOT EDIT ",
152a154
>       "type": "verify_info",
155,156c157
<       "key_types": [],
<       "type": "verify_info"
---
>       "key_types": []
159a161
>       "type": "whitelist_info",
162,163c164
<       "key_types": [],
<       "type": "whitelist_info"
---
>       "key_types": []
167,168d167
<   "error_messages": [],
<   "abi_extensions": [],
```

Compare the two abi's manually. if they are "logically" the same (one has a field missing while the other one is empty is fine like in the example above). They can be considered equal.
